/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_SIMULAPAD                                                */
/* Tabela : SIMULAPAD                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 17/05/2004 - RENATA DINIZ                                                  */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_SIMULAPAD' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_SIMULAPAD
GO

CREATE TRIGGER DTULTATU_SIMULAPAD
ON SIMULAPAD
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'SIMULAPAD', null, 'CDSIMULAPAD='+ CDSIMULAPAD + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE SIMULAPAD
      SET DTULTATUSIMP = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(SIMULAPAD.CDSIMULAPAD ,0) = ISNULL(INSERTED.CDSIMULAPAD ,0)) AND
            (ISNULL(SIMULAPAD.NMSIMULAPAD ,0) = ISNULL(INSERTED.NMSIMULAPAD ,0));
   END;
END;
GO

